/*
 * Copyright (c) 2002, The EROS Group, LLC and Johns Hopkins
 * University. All rights reserved.
 * 
 * This software was developed to support the EROS secure operating
 * system project (http://www.eros-os.org). The latest version of
 * the OpenCM software can be found at http://www.opencm.org.
 * 
 * Redistribution and use in source and binary forms, with or
 * without modification, are permitted provided that the following
 * conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials
 *    provided with the distribution.
 * 
 * 3. Neither the name of the The EROS Group, LLC nor the name of
 *    Johns Hopkins University, nor the names of its contributors
 *    may be used to endorse or promote products derived from this
 *    software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
 * CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

/* OPCODE Format:  (Set up to allow a max of five arguments to/from the
 * server):
 * 
 * opname, number of arguments needed, type of arg1, type of arg2, ...
 * type of arg5 */

OPCODE(Null,            0, 0, 0, 0, 0, 0)
/* StartSession takes the place of connect() in the wire protocol */
OPCODE(StartSession,    2, TY_WireString, TY_WireUnsigned, 0, 0, 0)
OPCODE(Disconnect,      0, 0, 0, 0, 0, 0)
OPCODE(GetVersion,      0, 0, 0, 0, 0, 0)
OPCODE(ReviseEntity,    3, TY_WireString, TY_WireString, TY_Serializable, 0, 0)
OPCODE(GetEntity,       2, TY_WireString, TY_WireString, 0, 0, 0)
OPCODE(GetRevision,     2, TY_WireString, TY_WireUnsigned, 0, 0, 0)
OPCODE(PutRevision,     1, TY_Serializable, 0, 0, 0, 0)
OPCODE(CreateMutable,   4, TY_WireString, TY_WireString, TY_Serializable, 
                           TY_WireUnsigned, 0)
OPCODE(GetMutable,      1, TY_WireString, 0, 0, 0, 0)
OPCODE(ReviseMutable,   3, TY_WireString, TY_WireUnsigned, TY_Serializable,
                           0, 0)
OPCODE(SetMutableACL,   3, TY_WireString, TY_WireUnsigned,
                           TY_WireString, 0, 0)
OPCODE(DupMutable,      5, TY_WireString, TY_WireString, TY_WireUnsigned,
                           TY_WireUnsigned, TY_WireUnsigned)
OPCODE(SetMutableFlags, 2, TY_WireString, TY_WireUnsigned, 0, 0, 0)
OPCODE(SetMutableName,  2, TY_WireString, TY_WireString,   0, 0, 0)
OPCODE(SetMutableDesc,  2, TY_WireString, TY_WireString,   0, 0, 0)
OPCODE(BindUser,        2, TY_PubKey, TY_WireUnsigned, 0, 0, 0)
OPCODE(GetUser,         1, TY_PubKey, 0, 0, 0, 0)
OPCODE(GetUserAccess,   1, TY_PubKey, 0, 0, 0, 0)
/* Added in protocol version 2: */
OPCODE(ShutDown,        0, 0, 0, 0, 0, 0)
/* Added in protocol version 3: */
OPCODE(GetParents,      2, TY_WireString, TY_WireString, 0, 0, 0)
/* Added in protocol version 4: */
OPCODE(SetCompression,  2, TY_WireString, TY_WireUnsigned, 0, 0, 0)
/* Added in protocol version 5: (?) */
OPCODE(RebindUser,      2, TY_WireString, TY_PubKey, 0, 0, 0)

/* Added in protocol version 6: */
OPCODE(Enumerate,       3, TY_WireString, TY_WireUnsigned, TY_WireUnsigned, 0, 0)
/* Added in protocol version 7: */
OPCODE(GetEntityDelta,  3, TY_WireString, TY_WireString, TY_WireString, 0, 0)
OPCODE(ReviseEntityDelta, 3, TY_WireString, TY_WireString, TY_WireDelta, 0, 0)

OPCODE(GarbageCollect,  1, TY_WireUnsigned, 0, 0, 0, 0)

/* FIX: This is for a future, asynchronous protocol version. */
/* OPCODE(SyncRequests,    0, 0, 0, 0, 0, 0) */

#undef OPCODE

